-----------------------------------------------------------------------------------------------
-- Client Lua Script for BookLevelIcons
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------

 
-----------------------------------------------------------------------------------------------
-- MEMORIES
-- eType = 
---- 398 = esper AMP
---- 395 = engineer AMP
---- 394 = warrior AMP
---- 399 = Spellslinger AMP
---- 396 = medic AMP
---- 397 = stalker AMP
----
---- 320 = Arch catalyst
---- 321 = Arch catalyst
----
----
--
-- FR null string codes
-- 194
-- 160
-- 195
--
-----------------------------------------------------------------------------------------------




require "Window"
 
-----------------------------------------------------------------------------------------------
-- BookLevelIcons Module Definition
-----------------------------------------------------------------------------------------------
local BookLevelIcons = {} 

-----------------------------------------------------------------------
-- Localization fixes
--
local arrLocales = {
	[1] = "enUS",
	[2] = "deDE",
	[3] = "frFR",
--	[4] = "koKR",
}

function BLI_get3symb(str)
	str = string.gsub (str, "AMP", "")
	str = string.gsub (str, "VIP", "")
	str = string.gsub (str, ":", "")
	str = string.gsub (str, " ", "")
	str = string.gsub (str, string.char(194), "")
	str = string.gsub (str, string.char(160), "")
	local aa = ""
	local bb = string.sub (str, 1 ,20)
	local i = 1
	local j = 1
	while (j < 4) do
		aa = aa .. string.char(string.byte(str,i))
		if (string.byte(str,i) == 195) then
			j = j - 1	
		end
		i = i + 1
		j = j + 1
	end
	return (aa)
end


local function BLIGetLocale()
	local strCancel = Apollo.GetString(1)
	-- deDE
	if strCancel == "Abbrechen" then
		return arrLocales[2]
	end
	-- frFR
	if strCancel == "Annuler" then
		return arrLocales[3]
	end
	return arrLocales[1]
end


-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function BookLevelIcons:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	
    return o
end
function BookLevelIcons:Init()
    Apollo.RegisterAddon(self, false, "", {"GuildBank"})
end
 

-----------------------------------------------------------------------------------------------
-- BookLevelIcons OnLoad
-----------------------------------------------------------------------------------------------
function BookLevelIcons:OnLoad()
	self.xmlDoc = XmlDoc.CreateFromFile("BookLevelIcons.xml")

	Apollo.RegisterSlashCommand("bli", "OnBLIcommand", self)
	Apollo.RegisterEventHandler("GuildBankTab", 			"OnGuildBankTab", self) -- noficiation that a guild bank tab is loaded.
	Apollo.LoadSprites("NewSprite.xml")

	--Get the data for the addon Guild Bank
	local gbAddon = Apollo.GetAddon("GuildBank")
	--Override the HelperDrawBankItem function
	gbAddon.HelperDrawBankItem = self.HelperDrawBankItem
	if self.tUserSettings == nil then
		self.tUserSettings = {}
		self.tUserSettings.BLIshowAMPnames = true
		BLIshowAMPnames = true
		self.tUserSettings.showGreetings = true

	end
end


function BookLevelIcons:OnBLIcommand()
	if self.tUserSettings.BLIshowAMPnames ~= true then
		self.tUserSettings.BLIshowAMPnames = true
		BLIshowAMPnames = true
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System,  "\[BookLevelItems\]: Part of AMPs names toggled ON\nPlease, reopen GuildBank tab...")

	else
		self.tUserSettings.BLIshowAMPnames = false
		BLIshowAMPnames = false
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, "\[BookLevelItems\]: Part of AMPs names toggled off\nPlease, reopen GuildBank tab...")
	end

end


function BookLevelIcons:OnGuildBankTab()
	if 	self.tUserSettings.showGreetings then
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, "Thank you for using BookLevelIcons v.1.2.4.\nFor toggle part of AMP names - use /bli and reopen GuildBank.\nDeveloped by Sala")
	end
	self.tUserSettings.showGreetings = false
end


function BookLevelIcons:OnSave(eLevel)
	if (eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character) then
		return
	end

	local tSave = self.tUserSettings
---	SendVarToRover("sssa",tSave)
	return tSave
end

function BookLevelIcons:OnRestore(eLevel,tSavedData)
	if tSavedData ~= nil then
		self.tUserSettings = tSavedData	
		BLIshowAMPnames = self.tUserSettings.showAMPnames
		self.tUserSettings.showGreetings = true

	end
	
end  


function BookLevelIcons:GetShowAMPNames()
	return self.tUserSettings.showAMPnames
end  

-----------------------------------------------------------------------------------------------
-- BookLevelIcons Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

--Replacement of GuildBank Function
function BookLevelIcons:HelperDrawBankItem(itemDrawing, nTab, nInventorySlot)
	if not self.tWndRefs.tBankItemSlots or not self.tWndRefs.tBankItemSlots[nInventorySlot] then
		return
	end

	local Cata_Tier
	local Cata_Move
	local Cata_MoveSize
	local Cata_Move
	local ABBY

	local wndBankSlot = self.tWndRefs.tBankItemSlots[nInventorySlot]
	wndBankSlot:FindChild("BankItemIcon"):SetData(itemDrawing)
	wndBankSlot:FindChild("BankItemIcon"):SetSprite(itemDrawing:GetIcon())
	self:HelperBuildItemTooltip(wndBankSlot:FindChild("BankItemIcon"), itemDrawing)

	local itemEType 
	local itemShortName 
	itemEType = 0
	local ARR = itemDrawing:GetDetailedInfo()
	if (ARR.tPrimary ~= nil) then
		
		if (ARR.tPrimary.strName ~= nil) then
			if (BLIlocale == "enUS") then
				itemShortName = string.sub (ARR.tPrimary.strName, 1 ,3) .. " "
			elseif (BLIlocale == "frFR") then
				itemShortName = BLI_get3symb(ARR.tPrimary.strName)
			elseif (BLIlocale == "deDE") then
				itemShortName = BLI_get3symb(ARR.tPrimary.strName)
--				BLI_Pb(string.sub (ARR.tPrimary.strName, 6 ,12))
			end

		end

		if (ARR.tPrimary.eType ~= nil) then
			itemEType = ARR.tPrimary.eType
		end
--		SendVarToRover("ARR",ARR)
	end
	
	local itemType = itemDrawing:GetItemTypeName()
--	Print(itemType)
--	SendVarToRover("iType",itemType)
	if (itemEType == 320) or (itemEType == 321) then 
		if (itemEType == 320) then Cata_Type = "arch"
		elseif (itemEType == 321) then Cata_Type = "tech"
		end
		Cata = itemDrawing:GetDetailedInfo()
		ABBY = Cata.tPrimary
		if (Cata.tPrimary.tCatalyst == nil) then
			Cata_Move= "Random"
			Cata_Tier = 0
--			if (not(string.find(Cata.tPrimary.strFlavor, "formulas") == nil)) then
--				Cata_Type = "tech"
--			elseif (not(string.find(Cata.tPrimary.strFlavor, "blueprints") == nil)) then
--				Cata_Type = "arch"
--			elseif (not(string.find(Cata.tPrimary.strFlavor, "formules") == nil)) then
--				Cata_Type = "tech"
--			elseif (not(string.find(Cata.tPrimary.strFlavor, "plans") == nil)) then
--				Cata_Type = "arch"
--			elseif (not(string.find(Cata.tPrimary.strFlavor, "formules") == nil)) then
--				Cata_Type = "tech"
--			elseif (not(string.find(Cata.tPrimary.strFlavor, "plans") == nil)) then
--				Cata_Type = "arch"
--			end

--			Print(Cata_Type)
			if (not(string.find(Cata.tPrimary.strFlavor, "Novice") == nil)) then
				Cata_Tier = 1
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Apprentice") == nil)) then
				Cata_Tier = 2
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Journeyman") == nil)) then
				Cata_Tier = 3
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Artisan") == nil)) then
				Cata_Tier = 4
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Expert") == nil)) then
				Cata_Tier = 5
			elseif (not(string.find(Cata.tPrimary.strFlavor, "novice") == nil)) then
				Cata_Tier = 1
			elseif (not(string.find(Cata.tPrimary.strFlavor, "apprenti") == nil)) then
				Cata_Tier = 2
			elseif (not(string.find(Cata.tPrimary.strFlavor, "compagnon") == nil)) then
				Cata_Tier = 3
			elseif (not(string.find(Cata.tPrimary.strFlavor, "de ma") == nil)) then
				Cata_Tier = 4
			elseif (not(string.find(Cata.tPrimary.strFlavor, "expert") == nil)) then
				Cata_Tier = 5
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Novize") == nil)) then
				Cata_Tier = 1
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Lehli") == nil)) then
				Cata_Tier = 2
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Gesell") == nil)) then
				Cata_Tier = 3
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Fachmann") == nil)) then
				Cata_Tier = 4
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Experten") == nil)) then
				Cata_Tier = 5
			end
			if (not(string.find(Cata.tPrimary.strFlavor, "Slightly") == nil)) then
				Cata_MoveSize = "small"
			elseif (not(string.find(Cata.tPrimary.strFlavor, "Greatly") == nil)) then
				Cata_MoveSize = "big"
			elseif (not(string.find(Cata.tPrimary.strFlavor, "rement") == nil)) then
				Cata_MoveSize = "small"
			elseif (not(string.find(Cata.tPrimary.strFlavor, "rablement") == nil)) then
				Cata_MoveSize = "big"
			elseif (not(string.find(Cata.tPrimary.strFlavor, "etwas") == nil)) then
				Cata_MoveSize = "small"
			elseif (not(string.find(Cata.tPrimary.strFlavor, "deutlich") == nil)) then
				Cata_MoveSize = "big"
			end
		else
			if (Cata.tPrimary.tCatalyst.nDiscoveryMultiplier > 1) then
				Cata_Move="Disc"
			elseif  (Cata.tPrimary.tCatalyst.nCraftMultiplier > 1) then
				Cata_Move= "Craft"
			else
				Cata_Move= "Attracts"
			end
			if (Cata.tPrimary.tCatalyst.nDiscoveryMultiplier == 1.5) then
				Cata_MoveSize = "small"
			elseif (Cata.tPrimary.tCatalyst.nDiscoveryMultiplier == 2) then
				Cata_MoveSize = "big"
			end
			if (Cata.tPrimary.tCatalyst.nCraftMultiplier == 2) then
				Cata_MoveSize = "small"
			elseif (Cata.tPrimary.tCatalyst.nCraftMultiplier == 3) then
				Cata_MoveSize = "big"
			end
			Cata_Tier = Cata.tPrimary.tCatalyst.nTier
		end
--		Print(Cata_Move)
		if Cata_MoveSize == nil then
			Cata_MoveSize = "small"
		end
		if (Cata_Move == "Attracts") then
			ABBA = "NewSprite:BII_Catalyst_" .. Cata_Type .. "_" .. Cata_Move				
		else ABBA = "NewSprite:BII_Catalyst_" .. Cata_Type .. "_" .. Cata_Move .. "_" .. Cata_Tier .. "_" .. Cata_MoveSize
--		BLI_P(ABBA)
		end
		wndBankSlot:FindChild("BankItemIcon"):SetSprite(ABBA)
--		Print(ABBA)

--		ABBY = ABBY.tCatalyst
--		ABBY = ABBY.nTier
--		SendVarToRover("ABBY", ABBY)		
--		SendVarToRover("ABBA", ABBA)		
	

-- reduces randomness - 
-- increase size of disc targets - nDiscoveryMultiplier 
	-- 1.5 Sightly
	-- 2 Greatly
-- increase size of craft targets - nCraftMultiplier
	-- 2 Sightly
	-- 3 Greatly


	--Check if item type is a class AMP and if so replace the icon.
	elseif (itemEType == 394) then  ---- 394 = warrior AMP
		if ARR.tPrimary.arClassRequirement ~= nil then
			if (ARR.tPrimary.arSpells[1].strFailure == nil) and (ARR.tPrimary.arClassRequirement.bRequirementMet)  then
				wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Warrior_N")
			else wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Warrior")
			end
			if BLIshowAMPnames then
				wndBankSlot:FindChild("BankItemIcon"):SetText(itemShortName)
			end
		end

	elseif (itemEType == 399) then ---- 399 = Spellslinger AMP
		if ARR.tPrimary.arClassRequirement ~= nil then
			if (ARR.tPrimary.arSpells[1].strFailure == nil) and (ARR.tPrimary.arClassRequirement.bRequirementMet) then
				wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Spellslinger_N")
			else wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Spellslinger")
			end
			if BLIshowAMPnames then
				wndBankSlot:FindChild("BankItemIcon"):SetText(itemShortName)
			end
		end
	elseif (itemEType == 397) then  ---- 397 = stalker AMP
		if ARR.tPrimary.arClassRequirement ~= nil then
			if (ARR.tPrimary.arSpells[1].strFailure == nil) and (ARR.tPrimary.arClassRequirement.bRequirementMet) then
				wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Stalker_N")
			else wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Stalker")
			end
			if BLIshowAMPnames then
				wndBankSlot:FindChild("BankItemIcon"):SetText(itemShortName)
			end
		end
	elseif (itemEType == 396) then  ---- 397 = medic AMP
		if ARR.tPrimary.arClassRequirement ~= nil then
			if (ARR.tPrimary.arSpells[1].strFailure == nil) and (ARR.tPrimary.arClassRequirement.bRequirementMet) then
				wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Medic_N")
			else wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Medic")
			end
			if BLIshowAMPnames then
				wndBankSlot:FindChild("BankItemIcon"):SetText(itemShortName)
			end
		end
	elseif (itemEType == 395) then  ---- 397 = engineer AMP
		if ARR.tPrimary.arClassRequirement ~= nil then
			if (ARR.tPrimary.arSpells[1].strFailure == nil) and (ARR.tPrimary.arClassRequirement.bRequirementMet) then
				wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Engineer_N")
			else wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Engineer")
			end
			if BLIshowAMPnames then
				wndBankSlot:FindChild("BankItemIcon"):SetText(itemShortName)
			end
		end
	elseif (itemEType == 398) then  ---- 397 = esper AMP
		if ARR.tPrimary.arClassRequirement ~= nil then
			if (ARR.tPrimary.arSpells[1].strFailure == nil) and (ARR.tPrimary.arClassRequirement.bRequirementMet) then
				wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Esper_N")
			else wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Class_Icon_Esper")
			end
			if BLIshowAMPnames then
				wndBankSlot:FindChild("BankItemIcon"):SetText(itemShortName)
			end
		end
	elseif (itemEType == 254)-- 254 tailor
		or (itemEType == 255)-- 255 outfitter
		or (itemEType == 256)-- 256 Armorer
		or (itemEType == 257)-- 257 weaponsmith
		or (itemEType == 258)-- 258 Techno
		or (itemEType == 259)-- 258 Coocking
		then 
--		SendVarToRover("ArrItem",ARR)
		if ARR.tPrimary.arTradeskillReqs ~= nil then
			if (ARR.tPrimary.arTradeskillReqs[1].bCanLearn == true)
			and (ARR.tPrimary.arTradeskillReqs[1].bIsKnown == false)
			and (ARR.tPrimary.tLevelRequirement.bRequirementMet == true)
				then
				if itemEType == 254 then
					wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Tailor_N")
				elseif itemEType == 255 then
					wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Outfitter_N")
				elseif itemEType == 256 then
					wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Armorer_N")
				elseif itemEType == 257 then
					wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Weaponsmith_N")
				elseif itemEType == 258 then
					wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Technologist_N")
				elseif itemEType == 259 then
					wndBankSlot:FindChild("BankItemIcon"):SetSprite("NewSprite:BII_Coocking_N")
				end
			end
					
		end
	end
	
	local nStackCount = itemDrawing:GetStackCount()
	if nStackCount ~= 1 then
		wndBankSlot:FindChild("BankItemIcon"):SetText(nStackCount)
	end
	ARR = nil
end

-- Tehno lvl 5 
--	tPrimary
--		tLevelRequirement
--			tRequirementMet		true
--
-- 255 outfitter
-- 254 tailor
-- 257 weaponsmith
-- 256 Armorer
-- 258 Techno
--
--
--
--
--
--
--



-----------------------------------------------------------------------------------------------
-- BookLevelIcons Instance
-----------------------------------------------------------------------------------------------
local BookLevelIconsInst = BookLevelIcons:new()
BookLevelIconsInst:Init()
BLIshowAMPnames = true
BLIlocale = BLIGetLocale()

-----------------------------------------------------------------------------------------------
-- DEBUG!
-----------------------------------------------------------------------------------------------
--function BLI_P(str)
--	if str ~= nil then
--		Print(str)
--	else
--		Print("-nil value-")
--	end
--end
--
--function BLI_Pb(str)
--	if str ~= nil then
--		i = 1
--		while  i <= string.len(str) do
--			Print(string.sub(str,i,i) .. " = " .. string.byte(str,i) )
--			i = i + 1
--		end
--	else
--		Print("-nil value-")
--	end
--
--end


